
class JsonExpression {
  String _expression;
  JsonExpression(String expression) {
    this._expression = expression;
  }
  String toPath() {
    String ex = this._expression;
    if (ex[0] == "\$") {
      if (new RegExp(r"(\.){2,}").hasMatch(ex)) {
        Match match = new RegExp(r"(\.){2,}").allMatches(ex).toList()[0];
        var str = "";
        match.group(0).split("").forEach((item) {
          str += ".*\\/";
        });
        ex = ex.replaceAll(new RegExp(r"(\.){2,}"), str);
      }
      ex = ex.replaceAll(new RegExp(r"^\$\."), "^\\/");
      ex = ex.replaceAll(new RegExp(r"^\$"), "^\\/");
      ex = ex.replaceAll(".*", "\\/.*");
      ex = ex.replaceAll("[*]", "\\/.*");
      ex = ex.replaceAll(".", "\\/");
      ex = ex.replaceAll("\\/\*", "\.\*");
      //[0:1] or [0,1]
      Iterable<Match> matches =
          new RegExp(r"\[([0-9]+)(,|\:)([0-9]+)\](\+|)").allMatches(ex);
      matches.forEach((match) {
        if (match.group(4) == null) {
          ex = ex.replaceAll(match.group(0),
              "\\/[" + match.group(1) + "-" + match.group(3) + "]");
        } else {
          ex = ex.replaceAll(
              match.group(0),
              "\\/[" +
                  match.group(1) +
                  "-" +
                  match.group(3) +
                  "]" +
                  match.group(4));
        }
      });
      //[:3]
      Iterable<Match> matches_2 =
          new RegExp(r"\[(\:)([0-9]+)\]").allMatches(ex);
      matches_2.forEach((match) {
        ex = ex.replaceAll(match.group(0), "\\/[0-" + match.group(2) + "]");
      });
      //[3]
      Iterable<Match> matches_3 = new RegExp(r"\[([0-9]+)\]").allMatches(ex);
      matches_3.forEach((match) {
        ex = ex.replaceAll(match.group(0), "\\/[" + match.group(1) + "]");
      });
      if (ex.length > 3 &&
          !(new RegExp(r"\/$").hasMatch(ex)) &&
          !(new RegExp(r"\*$").hasMatch(ex))) {
        ex += '\\/\$';
      }
      //fix for \/\/
      ex = ex.replaceAll("\\/\\/", "\\/");
      return ex;
    } else {
      return ex.replaceAll("\//", "\\/");
    }
  }
}
