
import 'dart:async';
import 'dart:convert';
import 'dart:io';

class Streamer {
  File file;
  StreamController<String> _sc;
  Streamer(File file) {
    this.file = file;
    _sc = new StreamController<String>();
  }
  Stream<String> get start {
    this._serv();
    return _sc.stream;
  }

  _serv() {
    Stream<List<int>> inputStream;
    inputStream = file.openRead();
    inputStream.transform(utf8.decoder) // Decode bytes to UTF-8.
        .listen((String line) {
      _sc.add(line);
    }, onDone: () {
      _sc.close();
    }, onError: (e) {
      _sc.addError(e);
      _sc.close();
    });
  }
}
